unit Propaty;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, System.UITypes;

const
  FORM_WIDTH_SET       = 700;
  FORM_HEIGHT_SET      = 450;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  INIFILE_NAME             = 'MeryClipHistory.ini';
  DLL_FOLDER_NAME          = 'Plugins';
  TEXT_FOLDER_NAME         = 'MeryClipHistory';

  TEXT_FILE_NAME_1         = 'Text1.txt';
  TEXT_FILE_NAME_2         = 'Text2.txt';
  TEXT_FILE_NAME_3         = 'Text3.txt';
  TEXT_FILE_NAME_4         = 'Text4.txt';
  TEXT_FILE_NAME_5         = 'Text5.txt';
  TEXT_FILE_NAME_6         = 'Text6.txt';
  TEXT_FILE_NAME_DATETIME  = 'DateTime.txt';

type
  TFormPropaty = class(TForm)
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    ComboBox1: TComboBox;
    CheckBox2: TCheckBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    RadioGroup1: TRadioGroup;
    Label6: TLabel;
    ComboBox6: TComboBox;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ComboBox7: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    ButtonSettext: TButton;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ButtonSettextClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    BoolFormCloseOK: Boolean;
    StrIniFileName: String;
    StrMaxSize: String;
    StrLimit: String;
    StrDelayTime: String;

  public
    { Public 錾 }

  end;

var
  FormPropaty: TFormPropaty;

implementation

{$R *.dfm}

uses SetText;

procedure TFormPropaty.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormPropaty.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TiniFile;
begin
  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormPropaty', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormPropaty', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormPropaty', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormPropaty', 'Left',   FormPropaty.Left);
    IniFile.WriteInteger('FormPropaty', 'Top',    FormPropaty.Top);
    IniFile.WriteInteger('FormPropaty', 'Width',  FormPropaty.Width);
    IniFile.WriteInteger('FormPropaty', 'Height', FormPropaty.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormPropaty.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ;
end;

procedure TFormPropaty.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //őOʂɕ\
  FormStyle := fsStayOnTop;

  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;

  //
  BoolFormCloseOK := FALSE;
  BoolFormCloseOK := FALSE;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormPropaty', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormPropaty', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormPropaty', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormPropaty', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormPropaty', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ݒ
  CheckBox1.Checked     := IniFile.ReadBool     ('AutoStart',       'Enabled',  TRUE);
  CheckBox2.Checked     := IniFile.ReadBool     ('ShowEscChar',     'Enabled',  TRUE);
  RadioGroup1.ItemIndex := IniFile.ReadInteger  ('ShowType',        'Index',       0);
  ComboBox1.ItemIndex   := IniFile.ReadInteger  ('MaxShowLength',   'Index',       0);
  ComboBox2.ItemIndex   := IniFile.ReadInteger  ('MaxHistory',      'Index',       3);
  ComboBox3.ItemIndex   := IniFile.ReadInteger  ('MaxTextSize',     'Index',       1);
  ComboBox4.ItemIndex   := IniFile.ReadInteger  ('PasteDeleteKey',  'Index',       0);
  ComboBox5.ItemIndex   := IniFile.ReadInteger  ('DeleteKey',       'Index',       2);
  ComboBox6.ItemIndex   := IniFile.ReadInteger  ('DelayTime',       'Index',       2);
  ComboBox7.ItemIndex   := IniFile.ReadInteger  ('VclStyle',        'Index',       0);
  //j
  IniFile.Free;

  //ݒ
  ComboBox3Change(Sender);

  //L
  StrLimit     := ComboBox2.Text;
  StrMaxSize   := Combobox3.Text;
  StrDelayTime := Combobox6.Text;
end;

procedure TFormPropaty.FormDestroy(Sender: TObject);
begin
;
end;

procedure TFormPropaty.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  wRet8: Word;
  sStr8: String;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݒ
    sStr8 := 'I܂H';
    wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
    if wRet8 = mrYes then
    begin
      //ݾ
      ButtonCancelClick(Sender);
    end
    else
    begin
      //
    end;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormPropaty.FormResize(Sender: TObject);
begin
;
end;

procedure TFormPropaty.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormPropaty.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormPropaty.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormPropaty.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormPropaty.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormPropaty.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;
end;

procedure TFormPropaty.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
begin
  if ComboBox4.Text = ComboBox5.Text then
  begin
    Showmessage('uy[Xgɗ폜vƁu폜v́ÃL[̐ݒ͂ł܂');
    Exit;
  end;

  if (ComboBox2.Text <> StrLimit    ) or
     (Combobox3.Text <> StrMaxSize  ) or
     (Combobox6.Text <> StrDelayTime) then
  begin
    Showmessage('u𐔁v܂́u̍őTCYv܂́uxԁvύX܂' + #13#10 +
                ' U Mery Iĉ');
  end;

  //ݒ
  sStr1 := StringReplace(ComboBox3.Text, ',', '', [rfReplaceAll]);

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ݒ
  IniFile.WriteBool    ('AutoStart',       'Enabled', CheckBox1.Checked);
  IniFile.WriteBool    ('ShowEscChar',     'Enabled', CheckBox2.Checked);
  IniFile.WriteInteger ('ShowType',        'Index',   RadioGroup1.ItemIndex);
  IniFile.WriteInteger ('MaxShowLength',   'Index',   ComboBox1.ItemIndex);
  IniFile.WriteInteger ('MaxHistory',      'Index',   ComboBox2.ItemIndex);
  IniFile.WriteInteger ('MaxTextSize',     'Index',   ComboBox3.ItemIndex);
  IniFile.WriteInteger ('PasteDeleteKey',  'Index',   ComboBox4.ItemIndex);
  IniFile.WriteInteger ('DeleteKey',       'Index',   ComboBox5.ItemIndex);
  IniFile.WriteInteger ('DelayTime',       'Index',   ComboBox6.ItemIndex);
  IniFile.WriteInteger ('VclStyle',        'Index',   ComboBox7.ItemIndex);
  IniFile.WriteString  ('MaxShowLength',   'Text',    ComboBox1.Text);
  IniFile.WriteString  ('MaxHistory',      'Text',    ComboBox2.Text);
  IniFile.WriteString  ('MaxTextSize',     'Text',    sStr1);
  IniFile.WriteString  ('PasteDeleteKey',  'Text',    ComboBox4.Text);
  IniFile.WriteString  ('DeleteKey',       'Text',    ComboBox5.Text);
  IniFile.WriteString  ('DelayTime',       'Text',    ComboBox6.Text);
  IniFile.WriteString  ('VclStyle',        'Text',    ComboBox7.Text);
  //j
  IniFile.Free;

  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrOK;
end;

procedure TFormPropaty.ButtonSetTextClick(Sender: TObject);
begin
  //m
  FormSetText := TFormSetText.Create(Application);
  //\
  FormSetText.ShowModal;
  //j
  FormSetText.Free;
end;

procedure TFormPropaty.ComboBox3Change(Sender: TObject);
begin
  if      ComboBox3.ItemIndex = 0 then
  begin
    Label8.Caption := '1M oCg'
  end
  else if ComboBox3.ItemIndex = 1 then
  begin
    Label8.Caption := '10M oCg'
  end
  else if ComboBox3.ItemIndex = 2 then
  begin
    Label8.Caption := '100M oCg'
  end
  else if ComboBox3.ItemIndex = 3 then
  begin
    Label8.Caption := '1G oCg'
  end
  else
  begin
    Label8.Caption := ''
  end;
end;

procedure TFormPropaty.ButtonCancelClick(Sender: TObject);
begin
  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrCancel;
end;

end.
