unit SelectHistory;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, mPlugIn, Vcl.Menus, MemoEx, Vcl.ComCtrls;

const
  FORM_WIDTH_SET       = 720;
  FORM_HEIGHT_SET      = 480;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  LISTBOX1_WIDTH       = 675;

  cbhStop     = MaxInt;
  cbhClear    = MaxInt - 1;
  cbhProperty = MaxInt - 2;
  cbhForm     = MaxInt - 3;
  cbhSetText  = MaxInt - 4;
  cbhDateTime = MaxInt - 5;
  cbhText1    = MaxInt - 6;
  cbhText2    = MaxInt - 7;
  cbhText3    = MaxInt - 8;
  cbhText4    = MaxInt - 9;
  cbhText5    = MaxInt - 10;
  cbhText6    = MaxInt - 11;

  INIFILE_NAME             = 'MeryClipHistory.ini';
  DLL_FOLDER_NAME          = 'Plugins';
  TEXT_FOLDER_NAME         = 'MeryClipHistory';

  TEXT_FILE_NAME_1         = 'Text1.txt';
  TEXT_FILE_NAME_2         = 'Text2.txt';
  TEXT_FILE_NAME_3         = 'Text3.txt';
  TEXT_FILE_NAME_4         = 'Text4.txt';
  TEXT_FILE_NAME_5         = 'Text5.txt';
  TEXT_FILE_NAME_6         = 'Text6.txt';
  TEXT_FILE_NAME_DATETIME  = 'DateTime.txt';

type
  TFormSelectHistory = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    ButtonStop: TButton;
    ButtonCancel: TButton;
    ButtonDelete: TButton;
    ButtonSet: TButton;
    ButtonNextPopup: TButton;
    ButtonDeleteAll: TButton;
    ButtonPropaty: TButton;
    MainMenu1: TMainMenu;
    MenuShowMemo: TMenuItem;
    MenuDelete: TMenuItem;
    MenuBackSpace: TMenuItem;
    MenuExit: TMenuItem;
    MenuEscape: TMenuItem;
    N1: TMenuItem;
    Panel9: TPanel;
    Panel10: TPanel;
    ButtonSetText: TButton;
    Panel11: TPanel;
    Memo1: TMemoEx;
    ListBox1: TListBox;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    ButtonChangeHeight: TButton;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonSetClick(Sender: TObject);
    procedure ButtonNextPopupClick(Sender: TObject);
    procedure ButtonDeleteAllClick(Sender: TObject);
    procedure ButtonPropatyClick(Sender: TObject);
    procedure ButtonSetTextClick(Sender: TObject);
    procedure ButtonChangeHeightClick(Sender: TObject);

    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);

    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);

    procedure Panel2Click(Sender: TObject);

    procedure MenuShowMemoClick(Sender: TObject);
    procedure MenuDeleteClick(Sender: TObject);
    procedure MenuBackSpaceClick(Sender: TObject);
    procedure MenuEscapeClick(Sender: TObject);

    function GetDateTime(DateTime: String): String;
    procedure ReadHistoryList(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrIniFileName: String;

    BoolFormCloseOK: Boolean;
    BoolFormShow: Boolean;
    BoolShowEscChar: Boolean;
    IntItemMaxLen: Integer;
    IntMemoHeightRate: Integer;
    StrFormStyle: String;
    FDarkModeColor: TColor;

  public
    { Public 錾 }

  end;

var
  FormSelectHistory: TFormSelectHistory;

implementation

{$R *.dfm}

uses History, Propaty, SetText;

procedure TFormSelectHistory.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSelectHistory.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TiniFile;
begin
  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSelectHistory', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSelectHistory', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSelectHistory', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSelectHistory', 'Left',   FormSelectHistory.Left);
    IniFile.WriteInteger('FormSelectHistory', 'Top',    FormSelectHistory.Top);
    IniFile.WriteInteger('FormSelectHistory', 'Width',  FormSelectHistory.Width);
    IniFile.WriteInteger('FormSelectHistory', 'Height', FormSelectHistory.Height);
  end;
  //ۑ
  IniFile.WriteBool   ('Memo1',     'Show',     MenuShowMemo.Checked);
  IniFile.WriteBool   ('Delete',    'Enabled',  MenuDelete.Checked);
  IniFile.WriteBool   ('BackSpace', 'Show',     MenuBackSpace.Checked);
  IniFile.WriteBool   ('Escape',    'Enabled',  MenuEscape.Checked);
  IniFile.WriteInteger('Memo1',     'HeightRate',  IntMemoHeightRate);

  //j
  IniFile.Free;
end;

procedure TFormSelectHistory.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ;
end;

procedure TFormSelectHistory.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //őOʂɕ\
  FormStyle := fsStayOnTop;

  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;

  //Ȃ悤
  ButtonStop.Width := 1;
  ButtonStop.Height := 1;
  ButtonStop.Top := 0;
  ButtonStop.Left := 0;
  ButtonCancel.Width := 1;
  ButtonCancel.Height := 1;
  ButtonCancel.Top := 0;
  ButtonCancel.Left := 0;
  ButtonDelete.Width := 1;
  ButtonDelete.Height := 1;
  ButtonDelete.Top := 0;
  ButtonDelete.Left := 0;
  ButtonSet.Width := 1;
  ButtonSet.Height := 1;
  ButtonSet.Top := 0;
  ButtonSet.Left := 0;
  ButtonNextPopup.Width := 1;
  ButtonNextPopup.Height := 1;
  ButtonNextPopup.Top := 0;
  ButtonNextPopup.Left := 0;
  ButtonDeleteAll.Width := 1;
  ButtonDeleteAll.Height := 1;
  ButtonDeleteAll.Top := 0;
  ButtonDeleteAll.Left := 0;
  ButtonPropaty.Width := 1;
  ButtonPropaty.Height := 1;
  ButtonPropaty.Top := 0;
  ButtonPropaty.Left := 0;
  ButtonSetText.Width := 1;
  ButtonSetText.Height := 1;
  ButtonSetText.Top := 0;
  ButtonSetText.Left := 0;
  ButtonChangeHeight.Width := 1;
  ButtonChangeHeight.Height := 1;
  ButtonChangeHeight.Top := 0;
  ButtonChangeHeight.Left := 0;


  //
  Memo1.Lines.Clear;
  BoolFormShow := FALSE;
  BoolFormCloseOK := FALSE;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormSelectHistory', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSelectHistory', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSelectHistory', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSelectHistory', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSelectHistory', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ݒ
  BoolShowEscChar       :=           IniFile.ReadBool    ('ShowEscChar',    'Enabled', TRUE);
  IntItemMaxLen         :=  StrToInt(IniFile.ReadString  ('MaxShowLength',  'Text',    '30'));
  IntMemoHeightRate     :=           IniFile.ReadInteger ('Memo1',          'HeightRate', 2);
  MenuShowMemo.Checked  :=           IniFile.ReadBool    ('Memo1',          'Show',    TRUE);
  MenuDelete.Checked    :=           IniFile.ReadBool    ('Delete',         'Enabled', TRUE);
  MenuBackSpace.Checked :=           IniFile.ReadBool    ('BackSpace',      'Show',    TRUE);
  MenuEscape.Checked    :=           IniFile.ReadBool    ('Escape',         'Enabled', TRUE);
  StrFormStyle          :=           IniFile.ReadString  ('VclStyle',       'Text',    'Windows');
  FDarkModeColor    := StringToColor(IniFile.ReadString  ('Dark',    'Color',  '$262720'));
                                     IniFile.WriteString ('Dark',    'Color',  ColorToString(FDarkModeColor));
  //j
  IniFile.Free;

  //ݒ
  if StrFormStyle = 'Dark' then
  begin
    Memo1.Color         := FDarkModeColor;
    ListBox1.Color      := FDarkModeColor;
    Panel1.Color        := FDarkModeColor;
    Panel2.Color        := FDarkModeColor;
    Panel3.Color        := FDarkModeColor;
    Panel4.Color        := FDarkModeColor;
    Panel5.Color        := FDarkModeColor;
    Panel6.Color        := FDarkModeColor;
    Panel7.Color        := FDarkModeColor;
    Panel8.Color        := FDarkModeColor;
    Panel9.Color        := FDarkModeColor;
    Panel10.Color       := FDarkModeColor;
    Panel11.Color       := FDarkModeColor;
    Panel12.Color       := FDarkModeColor;
    Panel13.Color       := FDarkModeColor;
    Panel14.Color       := FDarkModeColor;
    Panel15.Color       := FDarkModeColor;
    Panel16.Color       := FDarkModeColor;
    Panel17.Color       := FDarkModeColor;
    Panel18.Color       := FDarkModeColor;
    Panel19.Color       := FDarkModeColor;

    Memo1.Font.Color      := clWhite;
    ListBox1.Font.Color   := clWhite;
    Panel1.Font.Color     := clWhite;
    Panel2.Font.Color     := clWhite;
    Panel3.Font.Color     := clWhite;
    Panel4.Font.Color     := clWhite;
    Panel5.Font.Color     := clWhite;
    Panel6.Font.Color     := clWhite;
    Panel7.Font.Color     := clWhite;
    Panel8.Font.Color     := clWhite;
    Panel9.Font.Color     := clWhite;
    Panel10.Font.Color    := clWhite;
    Panel11.Font.Color    := clWhite;
    Panel12.Font.Color    := clWhite;
    Panel13.Font.Color    := clWhite;
    Panel14.Font.Color    := clWhite;
    Panel15.Font.Color    := clWhite;
    Panel16.Font.Color    := clWhite;
    Panel17.Font.Color    := clWhite;
    Panel18.Font.Color    := clWhite;
    Panel19.Font.Color    := clWhite;
  end;

  //XV
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;

  //XV
  if FormHistory.MaxSize = 1000000 then
  begin
    Panel15.Caption := '޲:1M';
  end;
  if FormHistory.MaxSize = 10000000 then
  begin
    Panel15.Caption := '޲:10M';
  end;
  if FormHistory.MaxSize = 100000000 then
  begin
    Panel15.Caption := '޲:100M';
  end;
  if FormHistory.MaxSize = 1000000000 then
  begin
    Panel15.Caption := '޲:1G';
  end;
  Panel16.Caption := 'x:' + IntToStr(FormHistory.Delay);
  Panel17.Caption := ':' + IntToStr(IntItemMaxLen);
  Panel15.Refresh;
  Panel16.Refresh;
  Panel17.Refresh;

  //Ǎ
  ReadHistoryList(Sender);

end;

procedure TFormSelectHistory.FormDestroy(Sender: TObject);
begin
;
end;

procedure TFormSelectHistory.FormKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) and (MenuEscape.Checked = TRUE) then
  begin
    //I
    ButtonCancelClick(Sender);
  end
  //Delete
  else if (Shift = []) and (key = VK_DELETE) and (MenuDelete.Checked)then
  begin
    //폜
    if ListBox1.Focused = TRUE then
    begin
      ButtonDeleteClick(Sender);
    end;
  end
  //Back
  else if (Shift = []) and (key = VK_BACK) and (MenuBackSpace.Checked)then
  begin
    //폜
    if ListBox1.Focused = TRUE then
    begin
      ButtonDeleteClick(Sender);
    end;
  end
  else if (Shift = []) and (key = VK_RETURN) and (ListBox1.Focused = TRUE) then
  begin
    //
    ButtonSetClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormSelectHistory.FormResize(Sender: TObject);
begin
  Memo1.Height := (FormSelectHistory.ClientHeight - Panel1.Height) div IntMemoHeightRate;
end;

procedure TFormSelectHistory.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSelectHistory.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSelectHistory.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSelectHistory.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSelectHistory.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSelectHistory.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 5, 0);

  //ݒ
  BoolFormShow := TRUE;

end;

procedure TFormSelectHistory.ListBox1Click(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  StrList1: TStringList;
begin
  if ListBox1.Count > 0 then
  begin
      //NA
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Clear;
      Memo1.Lines.EndUpdate;

      //m
      StrList1 := TStringList.Create;

      //擪
      sStr1 := Copy(ListBox1.Items.Strings[ListBox1.ItemIndex], 1, 1);
      //
      if      sStr1 = 'O' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
        if FileExists(sStr3) = TRUE then
        begin
          Memo1.Lines.BeginUpdate;
          Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
          Memo1.Lines.EndUpdate;
          if Memo1.Lines.Count >= 2 then
          begin
            Memo1.Lines.Delete(0);
          end;
          Memo1.Lines.EndUpdate;
        end;
      end
      else if sStr1 = 'P' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
        if FileExists(sStr3) = TRUE then
        begin
          Memo1.Lines.BeginUpdate;
          Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
          Memo1.Lines.EndUpdate;
          if Memo1.Lines.Count >= 2 then
          begin
            Memo1.Lines.Delete(0);
          end;
          Memo1.Lines.EndUpdate;
        end;
      end
      else if sStr1 = 'Q' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
        if FileExists(sStr3) = TRUE then
        begin
          Memo1.Lines.BeginUpdate;
          Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
          Memo1.Lines.EndUpdate;
          if Memo1.Lines.Count >= 2 then
          begin
            Memo1.Lines.Delete(0);
          end;
          Memo1.Lines.EndUpdate;
        end;
      end
      else if sStr1 = 'R' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
        if FileExists(sStr3) = TRUE then
        begin
          Memo1.Lines.BeginUpdate;
          Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
          Memo1.Lines.EndUpdate;
          if Memo1.Lines.Count >= 2 then
          begin
            Memo1.Lines.Delete(0);
          end;
          Memo1.Lines.EndUpdate;
        end;
      end
      else if sStr1 = 'S' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
        if FileExists(sStr3) = TRUE then
        begin
          Memo1.Lines.BeginUpdate;
          Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
          Memo1.Lines.EndUpdate;
          if Memo1.Lines.Count >= 2 then
          begin
            Memo1.Lines.Delete(0);
          end;
          Memo1.Lines.EndUpdate;
        end;
      end
      else if sStr1 = 'T' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
        if FileExists(sStr3) = TRUE then
        begin
          Memo1.Lines.BeginUpdate;
          Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
          Memo1.Lines.EndUpdate;
          if Memo1.Lines.Count >= 2 then
          begin
            Memo1.Lines.Delete(0);
          end;
          Memo1.Lines.EndUpdate;
        end;
      end
      else if sStr1 = 'X' then
      begin
        //t@Cǂݍ
        sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
        if FileExists(sStr3) = TRUE then
        begin
          StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
          if StrList1.Count >= 2 then
          begin
            //ϊ
            sStr2 := GetDateTime(StrList1.Strings[1]);
            //ݒ
            Memo1.Lines.BeginUpdate;
            Memo1.Lines.Clear;
            Memo1.Text := sStr2;
            Memo1.Lines.EndUpdate;
          end;
        end;
      end
      else if sStr1 = 'Y' then
      begin
        //̂܂
      end
      else if sStr1 = 'Z' then
      begin
        //̂܂
      end
      else
      begin
        //ݒ
        Memo1.Lines.BeginUpdate;
        Memo1.Lines.Clear;
        Memo1.Text := FormHistory.List[ListBox1.ItemIndex];
        Memo1.Lines.EndUpdate;
      end;
      //j
      StrList1.Free;
    end;
    //\
    Panel13.Caption := IntToStr(ListBox1.ItemIndex+1) + '/' +
                                       IntToStr(ListBox1.Items.Count);
    Panel14.Caption := ':' + IntToStr(FormHistory.Limit);
    Panel13.Refresh;
    Panel14.Refresh;
end;

procedure TFormSelectHistory.ListBox1DblClick(Sender: TObject);
begin
  if ListBox1.Items.Count > 0 then
  begin
      //
      ButtonSetClick(Sender);
  end;
end;

procedure TFormSelectHistory.MenuBackSpaceClick(Sender: TObject);
begin
  if MenuBackSpace.Checked = TRUE then
  begin
    MenuBackSpace.Checked := FALSE;
  end
  else
  begin
    MenuBackSpace.Checked := TRUE;
  end;
end;

procedure TFormSelectHistory.MenuDeleteClick(Sender: TObject);
begin
  if MenuDelete.Checked = TRUE then
  begin
    MenuDelete.Checked := FALSE;
  end
  else
  begin
    MenuDelete.Checked := TRUE;
  end;
end;

procedure TFormSelectHistory.MenuEscapeClick(Sender: TObject);
begin
  if MenuEscape.Checked = TRUE then
  begin
    MenuEscape.Checked := FALSE;
  end
  else
  begin
    MenuEscape.Checked := TRUE;
  end;
end;

procedure TFormSelectHistory.MenuShowMemoClick(Sender: TObject);
begin
  if MenuShowMemo.Checked = TRUE then
  begin
    MenuShowMemo.Checked := FALSE;
    Memo1.Visible := FALSE;
  end
  else
  begin
    MenuShowMemo.Checked := TRUE;
    Memo1.Visible := TRUE;
  end;
  //tH[JX߂
  if BoolFormShow = TRUE then
  begin
    ListBox1.SetFocus;
  end;
end;

procedure TFormSelectHistory.Panel2Click(Sender: TObject);
begin
  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrCancel;
end;

procedure TFormSelectHistory.ButtonChangeHeightClick(Sender: TObject);
begin
  if Memo1.Visible = FALSE then
  begin
    Showmessage('ʉ̏ڍו\ɂȂĂ܂');
    Exit;
  end;

  //ύX
  IntMemoHeightRate := IntMemoHeightRate+1;
  if IntMemoHeightRate > 7 then
  begin
    IntMemoHeightRate := 2;
  end;
  //TCY
  FormResize(Sender);
end;

procedure TFormSelectHistory.ButtonDeleteAllClick(Sender: TObject);
var
  iRow1: Integer;
  sStr1: String;
begin
  if ListBox1.Items.Count > 0 then
  begin
    //s
    for iRow1 := ListBox1.Items.Count-1 downto 0 do
    begin
      //擪擾
      sStr1 := Copy(ListBox1.Items.Strings[iRow1], 1, 1);
      //
      if (sStr1 = 'O') or (sStr1 = 'P') or (sStr1 = 'Q') or
         (sStr1 = 'R') or (sStr1 = 'S') or (sStr1 = 'T') or
         (sStr1 = 'U') or (sStr1 = 'V') or (sStr1 = 'W') or
         (sStr1 = 'X') or (sStr1 = 'Y') or (sStr1 = 'Z') then
      begin
        //
      end
      else
      begin
        //폜
        ListBox1.Items.Delete(iRow1);
        FormHistory.Delete(iRow1);
      end;
    end;

    //Đݒ
    if ListBox1.Items.Count > 0 then
    begin
      //ݒ
      ListBox1.ItemIndex := 0;
      ListBox1Click(Sender);
    end
    else
    begin
      //NA
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Clear;
      Memo1.Lines.EndUpdate;
    end;

    //\
    if ListBox1.Count = 0 then
    begin
      Panel13.Caption := '';
      Panel14.Caption := ':' + IntToStr(FormHistory.Limit);
      Panel13.Refresh;
      Panel14.Refresh;
    end;

    //tH[JX߂
    if BoolFormShow = TRUE then
    begin
      ListBox1.SetFocus;
    end;
  end;
end;

procedure TFormSelectHistory.ButtonDeleteClick(Sender: TObject);
var
  iIndex1: Integer;
  sStr1: String;
begin
  if ListBox1.Items.Count > 0 then
  begin
    //擪擾
    sStr1 := Copy(ListBox1.Items.Strings[ListBox1.ItemIndex], 1, 1);
    //
    if (sStr1 = 'O') or (sStr1 = 'P') or (sStr1 = 'Q') or
       (sStr1 = 'R') or (sStr1 = 'S') or (sStr1 = 'T') or
       (sStr1 = 'U') or (sStr1 = 'V') or (sStr1 = 'W') or
       (sStr1 = 'X') or (sStr1 = 'Y') or (sStr1 = 'Z') then
    begin
      //
    end
    else
    begin
      //擾
      iIndex1 := ListBox1.ItemIndex;
      //폜
      ListBox1.Items.Delete(iIndex1);
      FormHistory.Delete(iIndex1);

      //Đݒ
      if ListBox1.Items.Count > 0 then
      begin
        if iIndex1 > ListBox1.Items.Count-1 then
        begin
          iIndex1 := ListBox1.Items.Count-1;
        end;
        //ݒ
        ListBox1.ItemIndex := iIndex1;
        ListBox1Click(Sender);
      end
      else
      begin
        //NA
        Memo1.Lines.BeginUpdate;
        Memo1.Lines.Clear;
        Memo1.Lines.EndUpdate;
      end;

      //\
      if ListBox1.Count = 0 then
      begin
        Panel13.Caption := '';
        Panel14.Caption := ':' + IntToStr(FormHistory.Limit);
        Panel13.Refresh;
        Panel14.Refresh;
      end;

      //tH[JX߂
      if BoolFormShow = TRUE then
      begin
        ListBox1.SetFocus;
      end;
    end;
  end;
end;

procedure TFormSelectHistory.ButtonNextPopupClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ۑ
  IniFile.WriteInteger ('ShowType',        'Index',   0);
  //j
  IniFile.Free;

  //~Ă̂ōċN
  FormHistory.Start;

  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrCancel;
end;

procedure TFormSelectHistory.ButtonPropatyClick(Sender: TObject);
var
  bResult: Boolean;
begin
  //m
  FormPropaty := TFormPropaty.Create(Application);
  //\
  if FormPropaty.ShowModal = mrOK then
  begin
    bResult := TRUE;
  end
  else
  begin
    bResult := FALSE;
  end;
  //j
  FormPropaty.Free;

  //~Ă̂ōċN
  FormHistory.Start;

  //Ǎ
  ReadHistoryList(Sender);

  //
  if bResult = TRUE then
  begin
    //I
    BoolFormCloseOK := TRUE;
    ModalResult := mrCancel;
  end
  else
  begin
    //Ǎ
    ReadHistoryList(Sender);
  end;
end;

procedure TFormSelectHistory.ButtonStopClick(Sender: TObject);
begin
  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrCancel;
end;

procedure TFormSelectHistory.CheckBox2Click(Sender: TObject);
begin
  //tH[JX߂
  if BoolFormShow = TRUE then
  begin
    ListBox1.SetFocus;
  end;
end;

procedure TFormSelectHistory.CheckBox3Click(Sender: TObject);
begin
  //tH[JX߂
  if BoolFormShow = TRUE then
  begin
    ListBox1.SetFocus;
  end;
end;

procedure TFormSelectHistory.ButtonSetClick(Sender: TObject);
var
  IniFile: TIniFile;
  iIndex1: Integer;
  sStr1: String;
begin
  if ListBox1.Items.Count > 0 then
  begin
    //擪擾
    sStr1 := Copy(ListBox1.Items.Strings[ListBox1.ItemIndex], 1, 1);
    //ݒ
    if      sStr1 = 'O' then
    begin
      iIndex1 := cbhText1;
    end
    else if sStr1 = 'P' then
    begin
      iIndex1 := cbhText2;
    end
    else if sStr1 = 'Q' then
    begin
      iIndex1 := cbhText3;
    end
    else if sStr1 = 'R' then
    begin
      iIndex1 := cbhText4;
    end
    else if sStr1 = 'S' then
    begin
      iIndex1 := cbhText5;
    end
    else if sStr1 = 'T' then
    begin
      iIndex1 := cbhText6;
    end
    else if sStr1 = 'X' then
    begin
      iIndex1 := cbhDateTime;
    end
    else if sStr1 = 'Y' then
    begin
      iIndex1 := cbhForm;
    end
    else if sStr1 = 'Z' then
    begin
      iIndex1 := cbhStop;
    end
    else
    begin
      iIndex1 := ListBox1.ItemIndex;
    end;

    //m
    IniFile := TIniFile.Create (StrIniFileName);
    //ۑ
    IniFile.WriteInteger('ListBox1', 'Index', iIndex1);
    //j
    IniFile.Free;

    //I
    BoolFormCloseOK := TRUE;
    ModalResult := mrOK;
  end
  else
  begin
    Showmessage('܂');
  end;
end;

procedure TFormSelectHistory.ButtonSetTextClick(Sender: TObject);
var
  bResult: Boolean;
begin
  //m
  FormSetText := TFormSetText.Create(Application);
  //\
  if FormSetText.ShowModal = mrOK then
  begin
    bResult := TRUE;
  end
  else
  begin
    bResult := FALSE;
  end;
  //j
  FormSetText.Free;

  //~Ă̂ōċN
  FormHistory.Start;

  //ǂǂݍ
  if (bResult = TRUE) then
  begin
    //Ǎ
    ReadHistoryList(Sender);
  end
  else
  begin
    //Ǎ
    ReadHistoryList(Sender);
  end;
end;

procedure TFormSelectHistory.ButtonCancelClick(Sender: TObject);
begin
  //~Ă̂ōċN
  FormHistory.Start;

  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrCancel;
end;

function TFormSelectHistory.GetDateTime(DateTime: String): String;
var
  StrList1: TStringList;
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sYear1: String;
  sMonth1: String;
  sDay1: String;
  sHour1: String;
  sMinute1: String;
  sSecond1: String;
  sYear2: String;
  sMonth2: String;
  sDay2: String;
  sHour2: String;
  sMinute2: String;
  sSecond2: String;
begin
//ȉ̍ڂ̐ݒ肪\ł
//yyyy NS
//mm   Q
//dd   Q
//hh   Q
//nn   Q
//ss   bQ
//
//YY NQ
//M  P܂͂Q
//D  P܂͂Q
//H  P܂͂Q
//N  P܂͂Q
//S  bP܂͂Q
//
//ł
//yyyy/mm/dd hh:mm:ss 2021/01/02 07:08:09
//YY/mm/dd hh:mm:ss   21/01/02 07:08:09
//yyyy/M/D H:N:S      2021/1/2 7:8:9
//yyyy/M/D H:N:S      2021/01/02 07:08:09

  //
  sStr6 := '';

  //m
  StrList1 := TStringList.Create;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //
        sStr5 := FormatDateTime('yyyy-mm-dd hh-nn-ss', Now);
        //擾
        sYear1   := Copy(sStr5,  1, 4);
        sMonth1  := Copy(sStr5,  6, 2);
        sDay1    := Copy(sStr5,  9, 2);
        sHour1   := Copy(sStr5, 12, 2);
        sMinute1 := Copy(sStr5, 15, 2);
        sSecond1 := Copy(sStr5, 18, 2);
        //擾
        sYear2   := Copy(sYear1, 3, 2);
        sMonth2  := StringReplace(sMonth1,  '0', '', [rfReplaceAll]);
        sDay2    := StringReplace(sDay1,    '0', '', [rfReplaceAll]);
        sHour2   := StringReplace(sHour1,   '0', '', [rfReplaceAll]);
        sMinute2 := StringReplace(sMinute1, '0', '', [rfReplaceAll]);
        sSecond2 := StringReplace(sSecond1, '0', '', [rfReplaceAll]);

        //擾
        sStr6 := StrList1.Strings[1];
        //u
        sStr6 := StringReplace(sStr6, 'yyyy', sYear1,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'mm',   sMonth1,  [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'dd',   sDay1,    [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'hh',   sHour1,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'nn',   sMinute1, [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'ss',   sSecond1, [rfReplaceAll]);
        //u
        sStr6 := StringReplace(sStr6, 'YY',   sYear2,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'M',    sMonth2,  [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'D',    sDay2,    [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'H',    sHour2,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'N',    sMinute2, [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'S',    sSecond2, [rfReplaceAll]);
      end;
    end;
  end;

  //m
  StrList1.Free;

  //
  Result := sStr6;
end;

procedure TFormSelectHistory.ReadHistoryList(Sender: TObject);
var
  iRow1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sMenuItem: String;
  StrList1: TStringList;
begin
  //NA
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;
  ListBox1.Items.EndUpdate;
  Memo1.Lines.BeginUpdate;
  Memo1.Lines.Clear;
  Memo1.Lines.EndUpdate;

  //m
  StrList1 := TStringList.Create;

  //f
  if FormHistory.Count > 0 then
  begin
    for iRow1 := 0 to FormHistory.Count-1 do
    begin
      //擾
      sStr1 := FormHistory.List[iRow1];
      //GXP[vu
      if BoolShowEscChar = TRUE then
      begin
        //u
        sStr1 := sStr1.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
        {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
      end;
      //\𐧌
      if Length(sStr1) > IntItemMaxLen then
      begin
        sStr1 :=Copy(sStr1, 1, IntItemMaxLen) + '...';
      end;
      //ǉ
      if      iRow1 < 10 then
      begin
        //1..0
        sStr2 := IntToStr((iRow1+1) mod 10);
      end
      else if iRow1 < 10+26 then
      begin
        //A..Z
        sStr2 := Char(Ord('A') + (iRow1-10));
      end
      else
      begin
        sStr2 := ' ';
      end;
      //ǉ
      ListBox1.Items.Add(sStr2 + ' ' + sStr1);
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'O ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'P ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'Q ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'R ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'S ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'T ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //擾
        sMenuItem := StrList1.Strings[0];
        //GXP[vu
        if BoolShowEscChar then
        begin
          //u
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen+1).Replace('\', '\\').Replace(^I, '\t').Replace(^J, '\n')
            {.Replace(^K, '\v').Replace(^L, '\f')}.Replace(^M, '\r');
        end;
        //\𐧌
        if Length(sMenuItem) > IntItemMaxLen then
        begin
          sMenuItem := sMenuItem.Substring(0, IntItemMaxLen) + '...';
        end;
        //V[gJbgǉ
        sMenuItem := 'X ' + sMenuItem;
        //ǉ
        ListBox1.Items.Add(sMenuItem);
      end;
    end;
  end;

  //ǉ
  ListBox1.Items.Add('Y ̓|bvAbv\');
  //ǉ
  ListBox1.Items.Add('Z Nbv{[h̒~');

  //XV
  ListBox1.Items.EndUpdate;

  //ݒ
  if ListBox1.Items.Count > 0 then
  begin
    //ݒ
    ListBox1.ItemIndex := 0;
    //\
    ListBox1Click(Sender);
  end;

  //j
  StrList1.Free;
end;

end.
