unit SetText;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls,
  IniFiles, System.UITypes, MemoEx;

const
  FORM_WIDTH_SET       = 640;
  FORM_HEIGHT_SET      = 450;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  INIFILE_NAME             = 'MeryClipHistory.ini';
  DLL_FOLDER_NAME          = 'Plugins';
  TEXT_FOLDER_NAME         = 'MeryClipHistory';

  TEXT_FILE_NAME_1         = 'Text1.txt';
  TEXT_FILE_NAME_2         = 'Text2.txt';
  TEXT_FILE_NAME_3         = 'Text3.txt';
  TEXT_FILE_NAME_4         = 'Text4.txt';
  TEXT_FILE_NAME_5         = 'Text5.txt';
  TEXT_FILE_NAME_6         = 'Text6.txt';
  TEXT_FILE_NAME_DATETIME  = 'DateTime.txt';

type
  TFormSetText = class(TForm)
    Panel1: TPanel;
    ButtonSaveAll: TButton;
    ButtonCancel: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    Panel2: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Panel5: TPanel;
    Panel6: TPanel;
    Label3: TLabel;
    Panel8: TPanel;
    Label4: TLabel;
    Panel10: TPanel;
    Label5: TLabel;
    Panel12: TPanel;
    Label6: TLabel;
    Panel14: TPanel;
    Label7: TLabel;
    Panel16: TPanel;
    Label8: TLabel;
    Panel18: TPanel;
    Label9: TLabel;
    Panel20: TPanel;
    Label10: TLabel;
    Panel22: TPanel;
    Label11: TLabel;
    Panel24: TPanel;
    Label12: TLabel;
    Panel26: TPanel;
    Label13: TLabel;
    Panel28: TPanel;
    Label14: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Memo1: TMemoEx;
    Memo2: TMemoEx;
    Memo3: TMemoEx;
    Memo4: TMemoEx;
    Memo5: TMemoEx;
    Memo6: TMemoEx;
    MemoEx1: TMemoEx;
    ButtonSave: TButton;
    ButtonDelete: TButton;
    ButtonDeleteAll: TButton;
    ButtonMakeSample: TButton;
    ButtonMakeSampleAll: TButton;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonSaveAllClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonDeleteAllClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonMakeSampleClick(Sender: TObject);
    procedure ButtonMakeSampleAllClick(Sender: TObject);

    procedure SaveTextFile(MemoText: TMemoEx; EditTitle: TEdit; Filename: String);
    procedure SaveDateTimeFile(EditTitle: TEdit; EditDateTime: TEdit; Filename: String);
    procedure DeleteTextFile(Filename: String);

    function MakeTextFile(TextTitle: String; TextText: String; Filename: String):Boolean;
    function MakeDateTimeFile(TextTitle: String; TextText: String; Filename: String): Boolean;

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrIniFileName: String;
    BoolShowEscChar: Boolean;
    BoolFormCloseOK: Boolean;
    IntItemMaxLen: Integer;

  public
    { Public 錾 }

  end;

var
  FormSetText: TFormSetText;

implementation

{$R *.dfm}

procedure TFormSetText.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSetText.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TiniFile;
begin
  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSetText', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSetText', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSetText', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSetText', 'Left',   FormSetText.Left);
    IniFile.WriteInteger('FormSetText', 'Top',    FormSetText.Top);
    IniFile.WriteInteger('FormSetText', 'Width',  FormSetText.Width);
    IniFile.WriteInteger('FormSetText', 'Height', FormSetText.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormSetText.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ;
end;

procedure TFormSetText.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr3: String;
  StrList1: TStringList;
begin
  //őOʂɕ\
  FormStyle := fsStayOnTop;

  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;

  //ݒ
  PageControl1.TabStop := FALSE;
  //NA
  Memo1.Lines.Clear;
  Memo2.Lines.Clear;
  Memo3.Lines.Clear;
  Memo4.Lines.Clear;
  Memo5.Lines.Clear;
  Memo6.Lines.Clear;
  Edit1.Text := '';
  Edit2.Text := '';
  Edit3.Text := '';
  Edit4.Text := '';
  Edit5.Text := '';
  Edit6.Text := '';
  Edit7.Text := '';
  Edit8.Text := '';

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ݒ
  PageControl1.ActivePageIndex := IniFile.ReadInteger('Setting', 'ActivePageIndex', 0);
  //ݒ
  BoolShowEscChar   :=          IniFile.ReadBool    ('ShowEscChar',    'Enabled', TRUE);
  IntItemMaxLen     := StrToInt(IniFile.ReadString  ('MaxShowLength',  'Text',    '30'));
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormSetText', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSetText', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSetText', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSetText', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSetText', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrList1 := TStringList.Create;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit1.Text := StrList1.Strings[0];
        //ݒ
        Memo1.Lines.BeginUpdate;
        Memo1.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
        if Memo1.Lines.Count >= 2 then
        begin
          Memo1.Lines.Delete(0);
        end;
        Memo1.Lines.EndUpdate;
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit2.Text := StrList1.Strings[0];
        //ݒ
        Memo2.Lines.BeginUpdate;
        Memo2.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
        if Memo2.Lines.Count >= 2 then
        begin
          Memo2.Lines.Delete(0);
        end;
        Memo2.Lines.EndUpdate;
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit3.Text := StrList1.Strings[0];
        //ݒ
        Memo3.Lines.BeginUpdate;
        Memo3.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
        if Memo3.Lines.Count >= 2 then
        begin
          Memo3.Lines.Delete(0);
        end;
        Memo3.Lines.EndUpdate;
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit4.Text := StrList1.Strings[0];
        //ݒ
        Memo4.Lines.BeginUpdate;
        Memo4.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
        if Memo4.Lines.Count >= 2 then
        begin
          Memo4.Lines.Delete(0);
        end;
        Memo4.Lines.EndUpdate;
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit5.Text := StrList1.Strings[0];
        //ݒ
        Memo5.Lines.BeginUpdate;
        Memo5.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
        if Memo5.Lines.Count >= 2 then
        begin
          Memo5.Lines.Delete(0);
        end;
        Memo5.Lines.EndUpdate;
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit6.Text := StrList1.Strings[0];
        //ݒ
        Memo6.Lines.BeginUpdate;
        Memo6.Lines.LoadFromFile(sStr3, TEncoding.Unicode);
        if Memo6.Lines.Count >= 2 then
        begin
          Memo6.Lines.Delete(0);
        end;
        Memo6.Lines.EndUpdate;
      end;
    end;
  end;

  //t@Cǂݍ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
  if FileExists(sStr3) = TRUE then
  begin
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    if StrList1.Count >= 2 then
    begin
      if StrList1.Strings[0] <> '' then
      begin
        //ݒ
        Edit7.Text := StrList1.Strings[0];
        //ݒ
        Edit8.Text := StrList1.Strings[1];
      end;
    end;
  end;

  //j
  StrList1.Free;
end;

procedure TFormSetText.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ݒ
  IniFile.WriteInteger('Setting', 'ActivePageIndex', PageControl1.ActivePageIndex);
  //j
  IniFile.Free;
end;

procedure TFormSetText.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  wRet8: Word;
  sStr8: String;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݒ
    sStr8 := 'I܂H';
    wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
    if wRet8 = mrYes then
    begin
      //ݾ
      ButtonCancelClick(Sender);
    end
    else
    begin
      //
    end;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormSetText.FormResize(Sender: TObject);
begin
;
end;

procedure TFormSetText.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSetText.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSetText.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSetText.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSetText.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSetText.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;
end;

procedure TFormSetText.ButtonDeleteClick(Sender: TObject);
var
  sStr3: String;
  sStr8: String;
  wRet8: Word;
begin
  //y[WmF
  if       PageControl1.ActivePageIndex = 0 then
  begin
    sStr8 := 'Information : Text1 폜܂H';
  end
  else if  PageControl1.ActivePageIndex = 1 then
  begin
    sStr8 := 'Information : Text2 폜܂H';
  end
  else if  PageControl1.ActivePageIndex = 2 then
  begin
    sStr8 := 'Information : Text3 폜܂H';
  end
  else if  PageControl1.ActivePageIndex = 3 then
  begin
    sStr8 := 'Information : Text4 폜܂H';
  end
  else if  PageControl1.ActivePageIndex = 4 then
  begin
    sStr8 := 'Information : Text5 폜܂H';
  end
  else if  PageControl1.ActivePageIndex = 5 then
  begin
    sStr8 := 'Information : Text6 폜܂H';
  end
  else if  PageControl1.ActivePageIndex = 6 then
  begin
    sStr8 := 'Information : DateTime 폜܂H';
  end
  else
  begin
    //
  end;

  //mF
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    ;
  end
  else
  begin
    Exit;
  end;

  //y[WmF
  if       PageControl1.ActivePageIndex = 0 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
    DeleteTextFile(sStr3);
    //NA
    Edit1.Text := '';
    Memo1.Lines.BeginUpdate;
    Memo1.Lines.Clear;
    Memo1.Lines.EndUpdate;
  end
  else if  PageControl1.ActivePageIndex = 1 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
    DeleteTextFile(sStr3);
    //NA
    Edit2.Text := '';
    Memo2.Lines.BeginUpdate;
    Memo2.Lines.Clear;
    Memo2.Lines.EndUpdate;
  end
  else if  PageControl1.ActivePageIndex = 2 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
    DeleteTextFile(sStr3);
    //NA
    Edit3.Text := '';
    Memo3.Lines.BeginUpdate;
    Memo3.Lines.Clear;
    Memo3.Lines.EndUpdate;
  end
  else if  PageControl1.ActivePageIndex = 3 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
    DeleteTextFile(sStr3);
    //NA
    Edit4.Text := '';
    Memo4.Lines.BeginUpdate;
    Memo4.Lines.Clear;
    Memo4.Lines.EndUpdate;
  end
  else if  PageControl1.ActivePageIndex = 4 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
    DeleteTextFile(sStr3);
    //NA
    Edit5.Text := '';
    Memo5.Lines.BeginUpdate;
    Memo5.Lines.Clear;
    Memo5.Lines.EndUpdate;
  end
  else if  PageControl1.ActivePageIndex = 5 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
    DeleteTextFile(sStr3);
    //NA
    Edit6.Text := '';
    Memo6.Lines.BeginUpdate;
    Memo6.Lines.Clear;
    Memo6.Lines.EndUpdate;
  end
  else if  PageControl1.ActivePageIndex = 6 then
  begin
    //t@C폜
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
    DeleteTextFile(sStr3);
    //NA
    Edit7.Text := '';
    Edit8.Text := '';
  end
  else
  begin
    //
  end;
end;

procedure TFormSetText.ButtonMakeSampleAllClick(Sender: TObject);
var
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  bRun: Boolean;
  bResult: Boolean;
  sStr8: String;
  wRet8: Word;
begin
  //mF
  sStr8 := 'Information : ꊇō쐬܂H';
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    ;
  end
  else
  begin
    Exit;
  end;

  //
  bRun := TRUE;

  //
  if bRun = TRUE then
  begin
    if (Edit1.Text <> '') or (Memo1.Text <> '') then
    begin
      sStr4 := 'Text1 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = TRUE then
  begin
    if (Edit2.Text <> '') or (Memo2.Text <> '') then
    begin
      sStr4 := 'Text2 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = TRUE then
  begin
    if (Edit3.Text <> '') or (Memo3.Text <> '') then
    begin
      sStr4 := 'Text3 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = TRUE then
  begin
    if (Edit4.Text <> '') or (Memo4.Text <> '') then
    begin
      sStr4 := 'Text4 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = TRUE then
  begin
    if (Edit5.Text <> '') or (Memo5.Text <> '') then
    begin
      sStr4 := 'Text5 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = TRUE then
  begin
    if (Edit6.Text <> '') or (Memo6.Text <> '') then
    begin
      sStr4 := 'Text6 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = TRUE then
  begin
    if (Edit7.Text <> '') or (Edit8.Text <> '') then
    begin
      sStr4 := 'DateTime ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end;

  //
  if bRun = FALSE then
  begin
    Showmessage(sStr4);
    Exit;
  end;

  //
  bResult := TRUE;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
    sStr5 := 'Text1 o';
    sStr6 := 'Text1̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit1.Text := sStr5;
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Clear;
      Memo1.Text := sStr6;
      Memo1.Lines.EndUpdate;
    end;
  end;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
    sStr5 := 'Text2 o';
    sStr6 := 'Text2̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit2.Text := sStr5;
      Memo2.Lines.BeginUpdate;
      Memo2.Lines.Clear;
      Memo2.Text := sStr6;
      Memo2.Lines.EndUpdate;
    end;
  end;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
    sStr5 := 'Text3 o';
    sStr6 := 'Text3̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit3.Text := sStr5;
      Memo3.Lines.BeginUpdate;
      Memo3.Lines.Clear;
      Memo3.Text := sStr6;
      Memo3.Lines.EndUpdate;
    end;
  end;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
    sStr5 := 'Text4 o';
    sStr6 := 'Text4̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit4.Text := sStr5;
      Memo4.Lines.BeginUpdate;
      Memo4.Lines.Clear;
      Memo4.Text := sStr6;
      Memo4.Lines.EndUpdate;
    end;
  end;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
    sStr5 := 'Text5 o';
    sStr6 := 'Text5̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit5.Text := sStr5;
      Memo5.Lines.BeginUpdate;
      Memo5.Lines.Clear;
      Memo5.Text := sStr6;
      Memo5.Lines.EndUpdate;
    end;
  end;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
    sStr5 := 'Text6 o';
    sStr6 := 'Text6̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit6.Text := sStr5;
      Memo6.Lines.BeginUpdate;
      Memo6.Lines.Clear;
      Memo6.Text := sStr6;
      Memo6.Lines.EndUpdate;
    end;
  end;

  //
  if bResult = TRUE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
    sStr5 := 'DateTime yyyy/mm/dd hh:nn:ss';
    sStr6 := 'yyyy/mm/dd hh:nn:ss';
    bResult := MakeDateTimeFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit7.Text := sStr5;
      Edit8.Text := sStr6;
    end;
  end;

  //s
  if bResult = FALSE then
  begin
    Exit;
  end;

  //
  Showmessage('t@C쐬܂');
end;

procedure TFormSetText.ButtonMakeSampleClick(Sender: TObject);
var
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  bRun: Boolean;
  bResult: Boolean;
begin
  //
  bRun := TRUE;

  //y[WmF
  if       PageControl1.ActivePageIndex = 0 then
  begin
    if (Edit1.Text <> '') or (Memo1.Text <> '') then
    begin
      sStr4 := 'Text1 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else if  PageControl1.ActivePageIndex = 1 then
  begin
    if (Edit2.Text <> '') or (Memo2.Text <> '') then
    begin
      sStr4 := 'Text2 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else if  PageControl1.ActivePageIndex = 2 then
  begin
    if (Edit3.Text <> '') or (Memo3.Text <> '') then
    begin
      sStr4 := 'Text3 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else if  PageControl1.ActivePageIndex = 3 then
  begin
    if (Edit4.Text <> '') or (Memo4.Text <> '') then
    begin
      sStr4 := 'Text4 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else if  PageControl1.ActivePageIndex = 4 then
  begin
    if (Edit5.Text <> '') or (Memo5.Text <> '') then
    begin
      sStr4 := 'Text5 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else if  PageControl1.ActivePageIndex = 5 then
  begin
    if (Edit6.Text <> '') or (Memo6.Text <> '') then
    begin
      sStr4 := 'Text6 ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else if  PageControl1.ActivePageIndex = 6 then
  begin
    if (Edit7.Text <> '') or (Edit8.Text <> '') then
    begin
      sStr4 := 'DateTime ̌oƓe󔒂ł͂܂̂Œ~܂';
      bRun := FALSE;
    end;
  end
  else
  begin
    //
  end;

  //
  if bRun = FALSE then
  begin
    Showmessage(sStr4);
    Exit;
  end;

  //
  bResult := TRUE;

  //y[WmF
  if       PageControl1.ActivePageIndex = 0 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
    sStr5 := 'Text1 o';
    sStr6 := 'Text1̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit1.Text := sStr5;
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Clear;
      Memo1.Text := sStr6;
      Memo1.Lines.EndUpdate;
    end;
  end
  else if  PageControl1.ActivePageIndex = 1 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
    sStr5 := 'Text2 o';
    sStr6 := 'Text2̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit2.Text := sStr5;
      Memo2.Lines.BeginUpdate;
      Memo2.Lines.Clear;
      Memo2.Text := sStr6;
      Memo2.Lines.EndUpdate;
    end;
  end
  else if  PageControl1.ActivePageIndex = 2 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
    sStr5 := 'Text3 o';
    sStr6 := 'Text3̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit3.Text := sStr5;
      Memo3.Lines.BeginUpdate;
      Memo3.Lines.Clear;
      Memo3.Text := sStr6;
      Memo3.Lines.EndUpdate;
    end;
  end
  else if  PageControl1.ActivePageIndex = 3 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
    sStr5 := 'Text4 o';
    sStr6 := 'Text4̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit4.Text := sStr5;
      Memo4.Lines.BeginUpdate;
      Memo4.Lines.Clear;
      Memo4.Text := sStr6;
      Memo4.Lines.EndUpdate;
    end;
  end
  else if  PageControl1.ActivePageIndex = 4 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
    sStr5 := 'Text5 o';
    sStr6 := 'Text5̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit5.Text := sStr5;
      Memo5.Lines.BeginUpdate;
      Memo5.Lines.Clear;
      Memo5.Text := sStr6;
      Memo5.Lines.EndUpdate;
    end;
  end
  else if  PageControl1.ActivePageIndex = 5 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
    sStr5 := 'Text6 o';
    sStr6 := 'Text6̓eł' + #13#10 + 's̎w肪\ł';
    bResult := MakeTextFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit6.Text := sStr5;
      Memo6.Lines.BeginUpdate;
      Memo6.Lines.Clear;
      Memo6.Text := sStr6;
      Memo6.Lines.EndUpdate;
    end;
  end
  else if  PageControl1.ActivePageIndex = 6 then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
    sStr5 := 'DateTime yyyy/mm/dd hh:nn:ss';
    sStr6 := 'yyyy/mm/dd hh:nn:ss';
    bResult := MakeDateTimeFile(sStr5, sStr6, sStr3);
    if bResult = TRUE then
    begin
      Edit7.Text := sStr5;
      Edit8.Text := sStr6;
    end;
  end
  else
  begin
    //
  end;

  //s
  if bResult = FALSE then
  begin
    Exit;
  end;

  //
  Showmessage('t@C쐬܂');
end;

procedure TFormSetText.ButtonDeleteAllClick(Sender: TObject);
var
  sStr3: String;
  sStr8: String;
  wRet8: Word;
begin
  //mF
  sStr8 := 'Information : ꊇō폜܂H';
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    ;
  end
  else
  begin
    Exit;
  end;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
  DeleteTextFile(sStr3);
  //NA
  Edit1.Text := '';
  Memo1.Lines.BeginUpdate;
  Memo1.Lines.Clear;
  Memo1.Lines.EndUpdate;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
  DeleteTextFile(sStr3);
  //NA
  Edit2.Text := '';
  Memo2.Lines.BeginUpdate;
  Memo2.Lines.Clear;
  Memo2.Lines.EndUpdate;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
  DeleteTextFile(sStr3);
  //NA
  Edit3.Text := '';
  Memo3.Lines.BeginUpdate;
  Memo3.Lines.Clear;
  Memo3.Lines.EndUpdate;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
  DeleteTextFile(sStr3);
  //NA
  Edit4.Text := '';
  Memo4.Lines.BeginUpdate;
  Memo4.Lines.Clear;
  Memo4.Lines.EndUpdate;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
  DeleteTextFile(sStr3);
  //NA
  Edit5.Text := '';
  Memo5.Lines.BeginUpdate;
  Memo5.Lines.Clear;
  Memo5.Lines.EndUpdate;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
  DeleteTextFile(sStr3);
  //NA
  Edit6.Text := '';
  Memo6.Lines.BeginUpdate;
  Memo6.Lines.Clear;
  Memo6.Lines.EndUpdate;

  //t@C폜
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
  DeleteTextFile(sStr3);
  //NA
  Edit7.Text := '';
  Edit8.Text := '';
end;

procedure TFormSetText.ButtonSaveClick(Sender: TObject);
var
  sStr3: String;
begin
  if       PageControl1.ActivePageIndex = 0 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
    SaveTextFile(Memo1, Edit1, sStr3);
  end
  else if  PageControl1.ActivePageIndex = 1 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
    SaveTextFile(Memo2, Edit2, sStr3);
  end
  else if  PageControl1.ActivePageIndex = 2 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
    SaveTextFile(Memo3, Edit3, sStr3);
  end
  else if  PageControl1.ActivePageIndex = 3 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
    SaveTextFile(Memo4, Edit4, sStr3);
  end
  else if  PageControl1.ActivePageIndex = 4 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
    SaveTextFile(Memo5, Edit5, sStr3);
  end
  else if  PageControl1.ActivePageIndex = 5 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
    SaveTextFile(Memo6, Edit6, sStr3);
  end
  else if  PageControl1.ActivePageIndex = 6 then
  begin
    //t@Cۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
    SaveDateTimeFile(Edit7, Edit8, sstr3);
  end
  else
  begin
    //
  end;

  //
  Showmessage('t@Cۑ܂');
end;

procedure TFormSetText.ButtonSaveAllClick(Sender: TObject);
var
  sStr3: String;
  sStr8: String;
  wRet8: Word;
begin
  //mF
  sStr8 := 'Information : ꊇŕۑ܂H';
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    ;
  end
  else
  begin
    Exit;
  end;

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_1;
  SaveTextFile(Memo1, Edit1, sStr3);

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_2;
  SaveTextFile(Memo2, Edit2, sStr3);

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_3;
  SaveTextFile(Memo3, Edit3, sStr3);

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_4;
  SaveTextFile(Memo4, Edit4, sStr3);

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_5;
  SaveTextFile(Memo5, Edit5, sStr3);

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_6;
  SaveTextFile(Memo6, Edit6, sStr3);

  //t@Cۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + TEXT_FOLDER_NAME  + '\' + TEXT_FILE_NAME_DATETIME;
  SaveDateTimeFile(Edit7, Edit8, sstr3);

  //
  Showmessage('t@Cۑ܂');
end;

procedure TFormSetText.ButtonCancelClick(Sender: TObject);
begin
  //I
  BoolFormCloseOK := TRUE;
  ModalResult := mrCancel;
end;

procedure TFormSetText.SaveTextFile(MemoText: TMemoEx; EditTitle: TEdit; Filename: String);
var
  StrList1: TStringList;
begin
  //m
  StrList1 := TStringList.Create;

  //ݒ
  StrList1.Clear;
  StrList1.Assign(MemoText.Lines);
  StrList1.Insert(0, EditTitle.Text);
  if StrList1.Strings[StrList1.Count-1]  = '' then
  begin
    StrList1.Delete(StrList1.Count-1);
  end;
  //t@Cۑ
  StrList1.SaveToFile(Filename, TEncoding.Unicode);

  //j
  StrList1.Free;
end;

procedure TFormSetText.SaveDateTimeFile(EditTitle: TEdit; EditDateTime: TEdit; Filename: String);
var
  StrList1: TStringList;
begin
  //m
  StrList1 := TStringList.Create;

  //ݒ
  StrList1.Clear;
  StrList1.Add(EditTitle.Text);
  StrList1.Add(EditDateTime.Text);
  //t@Cۑ
  StrList1.SaveToFile(Filename, TEncoding.Unicode);

  //j
  StrList1.Free;
end;


procedure TFormSetText.DeleteTextFile(Filename: String);
begin
  //t@C폜
  if FileExists(Filename) = TRUE then
  begin
    DeleteFile(Filename);
  end;
end;

function TFormSetText.MakeTextFile(TextTitle: String; TextText: String; Filename: String): Boolean;
var
  StrList1: TStringList;
begin
  //
  Result := TRUE;
  //
  if FileExists(FileName)  = TRUE then
  begin
    Showmessage(ExtractFileName(Filename) + ' ̃t@Cɂ̂ŁA쐬͒~܂');
    Result := FALSE;
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  //ǉ
  StrList1.Add(TextTitle);
  StrList1.Add(TextText);
  //ۑ
  StrList1.SaveToFile(FileName, TEncoding.Unicode);
  //j
  StrList1.Free;
end;

function TFormSetText.MakeDateTimeFile(TextTitle: String; TextText: String; Filename: String): Boolean;
var
  StrList1: TStringList;
begin
  //
  Result := TRUE;
  //
  if FileExists(FileName)  = TRUE then
  begin
    Showmessage(ExtractFileName(Filename) + ' ̃t@Cɂ̂ŁA쐬͒~܂');
    Result := FALSE;
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  //ǉ
  StrList1.Add(TextTitle);
  StrList1.Add(TextText);
  //ۑ
  StrList1.SaveToFile(FileName, TEncoding.Unicode);
  //j
  StrList1.Free;
end;

end.
